<?php                                                                                                                        
/*                                                                                                                           
Plugin Name: JLPoints&Rewards(en espa&ntilde;ol)                                                                                    
Plugin URI: http://es.codex.jumplane.com
Description:Con el plug-in de Jumplane de puntos y premios lograr&aacute;s generar mayor nivel de comentarios y participaci&oacute;n ofreciendo premios virtuales a aquellos usuarios con mayor actividad. Como administrador del blog f&aacute;cilmente podr&aacute;s subir y modificar el valor de cada avatar, monitorear resultados, y modificar todos los par&aacute;metros de la aplicaci&oacute;n. Los usuarios m&aacute;s activos podr&aacute;n acceder a avatares &uacute;nicos y as&iacute; poder diferenciarse del los dem&aacute;s, incentivando al resto a conseguir aquellos premios &uacute;nicos.
Version: 1.0                                                                                             
Author: Martorelli Sabrina (sabrina@jumplane.com) Colaborador: Ignacio Althabe ( nacho@jumplane.com)
Author URI: http://www.jumplane.com
*/


/*
	Copyright 2009  Jumplane (http://www.jumplane.com)
   
	This file is part of JL Points & Rewards

    JL Points & Rewards is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    JL Points & Rewards is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with JL Points & Rewards.  If not, see <http://www.gnu.org/licenses/>.

*/


require_once 'jlPointsClient.class.ext.php';
require_once 'jlPointsClient.class.php';



// Functions and Hooks for activation and desactivation 
function install() {
	
	global $wpdb;
	
	$table_name = $wpdb->prefix  . 'pointsk';
	


	$sql = 'CREATE TABLE `'.$table_name.'` (
			id bigint(20) NOT NULL AUTO_INCREMENT,
			API_KEY VARCHAR(200) NOT NULL,
			API_SECRET_KEY VARCHAR(200) NOT NULL,
			SERVER VARCHAR(200) NOT NULL,
			UNIQUE KEY id (id)
			) ENGINE=MyISAM DEFAULT CHARSET=utf8';
 
	$wpdb->query($sql);


	$table_name = $wpdb->prefix  . 'pointst';



	$sql = 'CREATE TABLE `'.$table_name.'` (
			id bigint(20) NOT NULL AUTO_INCREMENT,
			subject VARCHAR(200) NOT NULL,
			fromName VARCHAR(200) NOT NULL,
			fromEmail VARCHAR(200) NOT NULL,
			emailBody VARCHAR(500) NOT NULL,
			UNIQUE KEY id (id)
			) ENGINE=MyISAM DEFAULT CHARSET=utf8';
		 
	$wpdb->query($sql);

				
	$wpdb->query('INSERT INTO `wp_pointst` SET id="", subject="JL Points & Reward", fromName="El nombre de su Sitio", fromEmail="susitio@suserver.com", emailBody="Haga click en el siguiente link para ver su Premio"');

	
	}	
	

register_activation_hook(__FILE__, 'install'); 


function uninstall() {
	global $wpdb;
	
	$table_name = $wpdb->prefix  . 'pointsk';
 
	$sql = 'DROP TABLE `'.$table_name.'`';
	$wpdb->query($sql);

    $table_name = $wpdb->prefix  . 'pointst';
 
	$sql = 'DROP TABLE `'.$table_name.'`';
	$wpdb->query($sql);



	 }


register_deactivation_hook(__FILE__, 'uninstall'); 


//Fuction for get the APIKeys from the Data Base
function getAPIKeys(&$API_KEY,&$API_SECRET_KEY,&$SERVER){

	    global $wpdb;
		$result=$wpdb->get_row('SELECT * FROM `wp_pointsk` ORDER BY id DESC', ARRAY_A);
	    $API_KEY=$result[API_KEY];
		$API_SECRET_KEY=$result[API_SECRET_KEY];
		$SERVER=$result[SERVER];
}


//Fuction for get the Email Text from the Data Base
function getEmailText(&$subject,&$fromName,&$fromEmail,&$emailBody){

	    global $wpdb;
		$result=$wpdb->get_row('SELECT * FROM `wp_pointst`', ARRAY_A);
	    $subject=$result[subject];
		$fromName=$result[fromName];
		$fromEmail=$result[fromEmail];
		$emailBody=$result[emailBody];
}


//Function for send an email
function points_email($url,$useremail)  {

		getEmailText($subject,$fromName,$fromEmail,$emailBody);

		$header = 'From: '. $fromName . ' <' . $fromEmail . '>\r\n'; 

		$body=$emailBody.'    '.$url;

		mail($useremail, $subject, $body, $header); 

		return 0;
}




//Function and Hook for a comment made
function commentaction()
{
		 getAPIKeys($API_KEY,$API_SECRET_KEY,$SERVER);
		$jlpc = new jlPointsClient($API_KEY,$API_SECRET_KEY,$SERVER);
		$actions = $jlpc->GetActions();
		$act=(string)$actions[0]->name;
		if (is_user_logged_in()) {
				global $current_user;
				get_currentuserinfo();
				$email = $current_user->user_email;
				$jlpc->CollectPoints($email,$act);
		}
		else{

				$current=wp_get_current_commenter();
				$email=$current['comment_author_email'];
				$jlpc->CollectPoints($email,$act);
			}
}	

add_action('comment_post', 'commentaction');

 



//Function and Hook for a post publisher
function postaction()
{
		getAPIKeys($API_KEY,$API_SECRET_KEY,$SERVER);
		$jlpc = new jlPointsClient($API_KEY,$API_SECRET_KEY,$SERVER);
		$actions = $jlpc->GetActions();
		$act2=(string)$actions[1]->name;
		if (is_user_logged_in()) {
				global $current_user;
				get_currentuserinfo();
				$emailp = $current_user->user_email;
				$jlpc->CollectPoints($emailp,$act2);
		}
		
}	

add_action('publish_post', 'postaction');


function WidgetPoints_init()
{

//Ranking Widget
  function rankingPointsWidget($args)
  {
		extract($args);
		$options = get_option('rankingPointsWidget');
		$num = $options['rankingPointsWidget_num'];
		echo $before_widget; 
		echo $before_title . $options['rankingPointsWidget_title']. $after_title;
		getAPIKeys($API_KEY,$API_SECRET_KEY,$SERVER);
		$jlpc = new jlPointsClient($API_KEY,$API_SECRET_KEY,$SERVER);
		$users = $jlpc->GetRanking();
            
		echo'<table><tr>
			<th>Pos</th>
            <th>Usuario</th>
            <th>Puntos</th>
			</tr>';
		for($i = 0; $i < $num; $i++) {
             		  
			  echo '<tr>';
              echo '<td>'.(int)$users[$i]->position.'</td>';
			 $pos=strpos((string)$users[$i]->name,'@');
		     $name=substr((string)$users[$i]->name,0, $pos+5)." ...";

			  echo '<td>'.$name.'</td>';
			  echo '<td>'.(int)$users[$i]->points.'</td>';
			  echo '</tr>';
				}
		echo'</table>';
		echo'<br>';
		echo'JL Points & Rewards';
        echo $after_widget; 
	
  }

register_sidebar_widget('Ranking de Puntos ', 'rankingPointsWidget');

//Configuration of Ranking Widget

function rankingPointsWidget_config()
  {
	  $options = get_option('rankingPointsWidget');
	  if (!is_array($options)){
		  $options = array('rankingPointsWidget_title' =>'Ranking de Puntos', 'rankingPointsWidget_num' => 5);}
	
	  if ($_POST['rankingPointsWidget_submit']) {

		  $options['rankingPointsWidget_title'] = strip_tags(stripslashes($_POST['rankingPointsWidget_title']));
		  $options['rankingPointsWidget_num'] = (int) strip_tags(stripslashes($_POST['rankingPointsWidget_num']));
		  if($options['rankingPointsWidget_num']<1){$options['rankingPointsWidget_num']=1;}
    	  update_option('rankingPointsWidget', $options);
       }
	
	  $rankingPointsWidget_title = htmlspecialchars($options['rankingPointsWidget_title'], ENT_QUOTES);
	  $rankingPointsWidget_num = htmlspecialchars($options['rankingPointsWidget_num'], ENT_QUOTES);
	 	 
	  echo '<p>
	  <label>T&iacute;tulo</label>
	  <input type="text" class="widefat" id="rankingPointsWidget_title" name="rankingPointsWidget_title" value="' . $options['rankingPointsWidget_title'] .'">
	  </p>';
	  echo '<p>
	  <label >Cantidad de Usuarios:</label>
	  <input type="text" class="widefat" id="rankingPointsWidget_num" name="rankingPointsWidget_num" value="' . $options['rankingPointsWidget_num'] . '">
	  </p>';
	  echo '<input type="hidden" id="rankingPointsWidget_submit" name="rankingPointsWidget_submit" value="1" />';
  }

register_widget_control('Ranking de Puntos', 'rankingPointsWidget_config');


// Rewards Widget

function rewardsPointsWidget($args)
  {
	  extract($args);
	  global $current_user;
	  $options = get_option('rewardsPointsWidget');
	  echo $before_widget; 
	  echo $before_title . $options['rewardsPointsWidget_title']. $after_title;
	  if (is_user_logged_in()) {
			get_currentuserinfo();
			$email = $current_user->user_email;
	        getAPIKeys($API_KEY,$API_SECRET_KEY,$SERVER);
		    $jlpc = new jlPointsClient($API_KEY,$API_SECRET_KEY,$SERVER);
			$jlpcx = new jlPointsClientExt($API_KEY,$API_SECRET_KEY,$SERVER);
			$user = $jlpc->GetUserInfo($email);
			$actualPoints=(int)$user->pointsActual;
			$rewards = $jlpc->GetRewards();
			echo'<form method="post" action="wp-content/plugins/jl-points-rewardses/points-ManagerUser.php" id="action_form" name="form">  
			<table class="widefat" cellspacing="0">
			<thead>
			<tr>
			<th>&nbsp;</th>
			<th>Nombre</th>
            <th>Puntos</th>
			<th>Media</th>
			</tr>
			</thead>
			<tbody>
			';
			
		
			echo'<br/>';
			for($i = 0; $i < count($rewards); $i++) {
				  $points=(int)$rewards[$i]->points;
				  if($points <= $actualPoints){
					  echo '<tr>';
					  echo '<td> <INPUT TYPE="radio" name="userexchange[reward]"  value="'.(string)$rewards[$i]->name.'" /></td>';
					  echo '<td>'.(string)$rewards[$i]->name.'</td>';
					  echo '<td>'.(int)$rewards[$i]->points.'</td>';
					$linkMedia= $jlpcx->getRewardMedia($rewards[$i]->mid,$rewards[$i]->type,1);
					if ((boolean)$linkMedia){
						echo '<td><img src="'.$jlpcx->getRewardMedia($rewards[$i]->mid,$rewards[$i]->type,1).'"></td>';
					}else{
						echo '<td>No hay ning&uacute;n Media asociado</td>';
					}
					  
					  
					  echo '</tr>';
					   }
			     else{
					  echo '<tr>';
					  echo '<td> <INPUT TYPE="radio" name="userexchange[reward]"  value="" disabled /></td>';
					  echo '<td>'.(string)$rewards[$i]->name.'</td>';
					  echo '<td>'.(int)$rewards[$i]->points.'</td>';
					  $linkMedia= $jlpcx->getRewardMedia($rewards[$i]->mid,$rewards[$i]->type,1);
					if ((boolean)$linkMedia){
						echo '<td><img src="'.$jlpcx->getRewardMedia($rewards[$i]->mid,$rewards[$i]->type,1).'"></td>';
					}else{
						echo '<td>No hay ning&uacute;n Media asociado</td>';
					}
					  echo '</tr>';
					
					  }
     		  }
			echo'</tbody></table>
			<br/>
    		<input type="hidden" name="option" id="option" value="UserExchange" />
			<input type="hidden" name="userexchange[user]" id="action_user" value="'.$email.'"/>
			<input type="submit" name="submit" id="action_submit" value="Quiero Mi Premio!" />
	        </form>';
						echo'<br>';
		echo'JL Points & Rewards';
		}
	 else{	//Not logged in users

           getAPIKeys($API_KEY,$API_SECRET_KEY,$SERVER);
		   $jlpc = new jlPointsClient($API_KEY,$API_SECRET_KEY,$SERVER);
		   $jlpcx = new jlPointsClientExt($API_KEY,$API_SECRET_KEY,$SERVER);
		   $rewards = $jlpc->GetRewards();
     		echo'<form method="post" action="wp-content/plugins/jl-points-rewardses/points-ManagerUser.php" id="action_form" name="form">  
			<table class="widefat" cellspacing="0">
			<thead>
			<tr>
			<th>&nbsp;</th>
			<th>Nombre</th>
            <th>Puntos</th>
			<th>Media</th>

			</tr>
			</thead>
			<tbody>
			';
	    	  for($i = 0; $i < count($rewards); $i++) {
				  echo '<tr>';
				  echo '<td> <INPUT TYPE="radio" name="userexchange[reward]" value="'.(string)$rewards[$i]->name.'"</td>';
				  echo '<td>'.(string)$rewards[$i]->name.'</td>';
				  echo '<td>'.(int)$rewards[$i]->points.'</td>';
				  
				  $linkMedia= $jlpcx->getRewardMedia($rewards[$i]->mid,$rewards[$i]->type,1);
					if ((boolean)$linkMedia){
						echo '<td><img src="'.$jlpcx->getRewardMedia($rewards[$i]->mid,$rewards[$i]->type,1).'"></td>';
					}else{
						echo '<td>No hay ning&uacute;n Media asociado</td>';
					}
				  
				  
				  echo '</tr>';
			  }
			echo'</tbody></table>
			<br/>
		    <label for="action_user">Email:</label><br/>
            <input type="text" name="userexchange[user]" id="action_user" value="" size="15" />
          	<br/>		
			<br/>
            <input type="submit" name="submit" id="action_submit" value="Quiero mi Premio!"  />
			<input type="hidden" name="option" id="option" value="UserExchange" />
            </form>';
					echo'<br>';
		echo'JL Points & Rewards';
		}
	echo $after_widget; 
	
  }

register_sidebar_widget('Premios', 'rewardsPointsWidget');

//Configuration of Rewards Widget

function rewardsPointsWidget_config()
  {

	  $options = get_option('rewardsPointsWidget');
	  if (!is_array($options))  {
		  $options = array('rewardsPointsWidget_title' =>'Premios');
	   }
	  if ($_POST['rewardsPointsWidget_submit']) {
		  $options['rewardsPointsWidget_title'] = strip_tags(stripslashes($_POST['rewardsPointsWidget_title']));
		  update_option('rewardsPointsWidget', $options);
	   }
	  $rewardsPointsWidget_title= htmlspecialchars($options['rewardsPointsWidget_title'], ENT_QUOTES);
	  echo '<p>
	  <label>T&iacute;tulo</label>
	  <input type="text" class="widefat" id="rewardsPointsWidget_title" name="rewardsPointsWidget_title" value="' . $options['rewardsPointsWidget_title'] .'">
	  </p>';
	  echo '<input type="hidden" id="rewardsPointsWidget_submit" name="rewardsPointsWidget_submit" value="1" />';
  }

register_widget_control('Premios', 'rewardsPointsWidget_config');

//My Points and Rewards widget
function myPointsWidget($args)
  {
	
	  extract($args);
	  global $current_user;
	  $options = get_option('myPointsWidget');
	  echo $before_widget; 
	  echo $before_title . $options['myPointsWidget_title']. $after_title;
	  if (is_user_logged_in()) {
			get_currentuserinfo();
			$email = $current_user->user_email;
			getAPIKeys($API_KEY,$API_SECRET_KEY,$SERVER);
			$jlpc = new jlPointsClient($API_KEY,$API_SECRET_KEY,$SERVER);
			$jlpcx = new jlPointsClientExt($API_KEY,$API_SECRET_KEY,$SERVER);
			
			$user = $jlpc->GetUserInfo($email);
			$actualPoints=(int)$user->pointsActual;
			$totalPoints=(int)$user->points;
			echo'<strong>Puntos Totales:&nbsp;</strong>'.$totalPoints;
			echo'<br/>';
			echo'<strong>Puntos Actuales:&nbsp;</strong>'.$actualPoints;
			echo'<br/>';
			echo'<br/>';
			echo'<strong>Ultimo Premio</strong>';
    		$items = $jlpc->GetUserRewards($email);
		
			$i=0;
			
			$linkMedia= $jlpcx-> getUserRewardMedia($items[$i]->mid,$items[$i]->type,2);

			
			if ((boolean)$linkMedia){
						echo '<img src="'.$jlpcx-> getUserRewardMedia($items[$i]->mid,$items[$i]->type,2).'">';
					}else{
						echo 'No hay ning&uacute;n Media asociado';
					}
			
			
			echo'<br/>';
			echo'<br/>';
			echo (string)$items[$i]->name.'- '.(int)$items[$i]->points.' Puntos';
			echo'<br/>';
			echo (string)$items[$i]->createdAt;
			echo'<br/>';
					echo'<br>';
		echo'JL Points & Rewards';
		
	   }
     else{
			echo'<strong>Loggeate para ver tus Puntos y Premios</strong>';
					echo'<br>';
		echo'JL Points & Rewards';
				}
	 echo $after_widget; 
	
  }

register_sidebar_widget('Mis Puntos', 'myPointsWidget');

//Configuration of My Points and Reward Widget

function myPointsWidget_config()
  {
	  $options = get_option('myPointsWidget');
	  if (!is_array($options))
	  { $options = array('myPointsWidget_title' =>'Mis Puntos');}
	  if ($_POST['myPointsWidget_submit']) {
		  $options['myPointsWidget_title'] = strip_tags(stripslashes($_POST['myPointsWidget_title']));
		  update_option('myPointsWidget', $options);
	  }
	  $rewardsPointsWidget_title= htmlspecialchars($options['myPointsWidget_title'], ENT_QUOTES);
	  echo '<p>
	  <label>T&iacute;tulo:</label>
	  <input type="text" class="widefat" id="myPointsWidget_title" name="myPointsWidget_title" value="' . $options['myPointsWidget_title'] .'">
	  </p>';
	   echo '<input type="hidden" id="myPointsWidget_submit" name="myPointsWidget_submit" value="1" />';
  }

register_widget_control('Mis Puntos', 'myPointsWidget_config');



//All participant Widget
function allPointsWidget($args)
  {
	  extract($args);
      $options = get_option('allPointsWidget');
	  $num = $options['allPointsWidget_num'];
      echo $before_widget; 
	  echo $before_title . $options['allPointsWidget_title']. $after_title;
	  getAPIKeys($API_KEY,$API_SECRET_KEY,$SERVER);
	  $jlpc = new jlPointsClient($API_KEY,$API_SECRET_KEY,$SERVER);
	  
	  $users = $jlpc->GetRanking();
       echo'
	   <table>
	   <tr>            
       <th>Puntos</th>
	   <th>Usuario</th>
	   </tr></table>';
       echo '<div style="overflow:auto;height:150px;"><table>';
	   for($i = 0; $i < count($users); $i++) {
       	  echo '<tr>';
          echo '<td>'.(int)$users[$i]->points.'</td>';
		  
		  $pos=strpos((string)$users[$i]->name,'@');
		  $name=substr((string)$users[$i]->name,0, $pos+5)." ...";
			 
		  
		  echo '<td>'.$name.'</td>';
		 
		  

		  
		  echo '</tr>';
		}
	   echo'</table>';
	   echo'</div>';
	   		echo'<br>';
		echo'JL Points & Rewards';
	   echo $after_widget; 
	
  }




register_sidebar_widget('Puntos de Usuarios ', 'allPointsWidget');

//Configuration of All Participant Widget

function allPointsWidget_config()
  {
	  $options = get_option('allPointsWidget');
	  if (!is_array($options))
	  { $options = array('allPointsWidget_title' =>'Puntos de Usuarios');}
	
	  if ($_POST['allPointsWidget_submit']) {

		  $options['allPointsWidget_title'] = strip_tags(stripslashes($_POST['allPointsWidget_title']));
		
		  update_option('allPointsWidget', $options);
	  }
	  $rewardsPointsWidget_title= htmlspecialchars($options['allPointsWidget_title'], ENT_QUOTES);
	  echo '<p>
	  <label>T&iacute;tulo:</label>
	  <input type="text" class="widefat" id="allPointsWidget_title" name="allPointsWidget_title" value="' . $options['allPointsWidget_title'] .'">
	  </p>';
      echo '<input type="hidden" id="allPointsWidget_submit" name="allPointsWidget_submit" value="1" />';
  }

register_widget_control('Puntos de Usuarios', 'allPointsWidget_config');

} 


add_action('widgets_init', 'WidgetPoints_init');


// Function and Hook for administration Menu
function point_menu() {
	if (function_exists('add_menu_page')) {
		add_menu_page(__('JLPoints&Rewards', 'point'), __('JLPoints&Rewards', 'points'), 8,'jl-points-rewardses/points-Settings.php');
	}
	if (function_exists('add_submenu_page')) {

		add_submenu_page('jl-points-rewardses/points-Settings.php', __('Seteo', 'point'), __('Seteo', 'point'), 8, 'jl-points-rewardses/points-Settings.php');

		add_submenu_page('jl-points-rewardses/points-Settings.php', __('Configuracion', 'point'), __('Configuracion', 'point'), 8, 'jl-points-rewardses/points-Manager.php');
	
		add_submenu_page('jl-points-rewardses/points-Settings.php', __('Acciones', 'point'), __('Acciones ', 'point'), 8, 'jl-points-rewardses/points-Actions.php');
	
		add_submenu_page('jl-points-rewardses/points-Settings.php', __('Premios', 'point'), __('Premios', 'point'), 8, 'jl-points-rewardses/points-Rewards.php');

		add_submenu_page('jl-points-rewardses/points-Settings.php', __('Ranking', 'point'), __('Ranking', 'point'), 8, 'jl-points-rewardses/points-Ranking.php');

		add_submenu_page('jl-points-rewardses/points-Settings.php', __('Actividad Reciente', 'point'), __('Actividad Reciente', 'point'), 8, 'jl-points-rewardses/points-RecentActivity.php');
	
		
     }
}

add_action('admin_menu', 'point_menu');





?>