<?php
require_once 'jlPointsClient.class.php';
/*
	Copyright 2009  Jumplane (http://www.jumplane.com)
   
	This file is part of Jumplane Points

    Jumplane Points is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Jumplane Points is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Jumplane Points.  If not, see <http://www.gnu.org/licenses/>.

*/
class jlPointsClientExt extends jlPointsClient {
	
	protected $BaseUrlMedia;
	
	public function jlPointsClientExt($ApiKey, $ApiSecretKey, $BaseUrl = null) {
		parent::jlPointsClient ( $ApiKey, $ApiSecretKey, $BaseUrl );
		$media = explode ( "/", $this->BaseUrl );
		$this->BaseUrlMedia = 'http://' . $media [2] . '/';
	}
	
	public function getUserRewardMedia($mid, $type, $size) {
		$url = $this->BaseUrl . '/users/get_reward_media/' . $size . '/' . $mid;
		switch ($type) {
			case 2 :
				$url .= '.jpg';
				break;
			case 3 :
				if ($size == 1 || $size == 2) {
					$url .= '.jpg';
				} else {
					$url .= '.mp3';
				}
				break;
			case 4 :
				$url .= '.flv';
				break;
		}
		return $url;
	}
	
	public function getRewardMedia($Mid, $Type, $Size) {
		
		if ($Mid != '0') {
			$url = $this->BaseUrl . '/reward/getMedia/' . $Size . '/' . $Mid;
			switch ($type) {
				case 2 :
					$url .= '.jpg';
					break;
				case 3 :
					if ($size == 1 || $size == 2) {
						$url .= '.jpg';
					} else {
						$url .= '.mp3';
					}
					break;
				case 4 :
					$url .= '.flv';
					break;
			}
			return $url;
		}
		return false;
	}
	
	protected $token = false;
	
	public function getUploadForm($id = "JumplaneUploader", $background = 'FFFFFF', $barColor = '000000', $startMessage = "Please select a file", $errorSizeMessage = "File is too big!", $validFileMessage = "Thanks, now hit Upload!", $progressMessage = "Please wait, uploading", $endMessage = "and don't you come back)") {
		$url = "uploader/newToken";
		$response = $this->Post ( $url );
		$token = $response->data->uploader->token;
		$startMessage = rawurlencode ( $startMessage );
		$errorSizeMessage = rawurlencode ( $errorSizeMessage );
		$validFileMessage = rawurlencode ( $validFileMessage );
		$progressMessage = rawurlencode ( $progressMessage );
		$endMessage = rawurlencode ( $endMessage );
		$mediaUrl = $this->BaseUrlMedia;
		$uploadScript = $this->BaseUrl . '/upload/' . $token;
		$out = "<embed height=\"85\" width=\"320\" params=\"quality=high,menu=true\"bgcolor=\"#$background\" id=\"movie_player-0\"type=\"application/x-shockwave-flash\" src=\"$mediaUrl/uploader/uploader.swf\"pluginspage=\"http://www.adobe.com/go/getflashplayer\"flashvars=\"uploadScript=$uploadScript&amp;afterScript=&amp;allowedExt=*&amp;allowedExtDescr=Media%20File&amp;varName=file&amp;barColor=$barColor&amp;startMessage=$startMessage&amp;errorSizeMessage=$errorSizeMessage&amp;validFileMessage=$validFileMessage&amp;progressMessage=$progressMessage&amp;endMessage=$endMessage&amp;\" />";
		return array ('embed' => $out, 'token' => $token );
	}
	
	public function CreateReward($Id, $Label, $Points, $Token = null) {
		$url = "rewards/create";
		$data = "rewardId=$Id&rewardLabel=$Label&rewardPoints=$Points";
		if ($Token != null) {
			$data .= "&rewardMediaToken=$Token";
		}
		$response = $this->Post ( $url, $data );
		return $response->data->reward;
	}
	
	/**
	 * Modifies an existing reward.
	 *
	 * @param string $Id name of the reward to modify
	 * @param string $Label new label for the reward
	 * @param string $Points points needed by any user who wants to exchange points by this reward
	 * @return reward a reward object containing information about the modified reward.
	 *
	 * Example:
	 *
	 * <code>
	 * $jlpc = new jlPointsClient(API_KEY, API_SECRET_KEY);
	 * $reward = $jlpc->ModifyReward("reward1","label1",10);
	 * echo (string)$reward->name;
	 * echo (string)$reward->label;
	 * echo (int)$reward->points;
	 * </code>
	 */
	function ModifyReward($Id, $Label = null, $Points = null, $Token = null) {
		$url = "rewards/modify";
		$data = "rewardId=$Id";
		if ($Label != null) {
			$data .= "&rewardLabel=$Label";
		}
		if ($Points != null) {
			$data .= "&rewardPoints=$Points";
		}
		if ($Token != null) {
			$data .= "&rewardMediaToken=$Token";
		}
		$response = $this->Post ( $url, $data );
		return $response->data->reward;
	}
	function ModifyRewardMediaToken($Id, $token) {
		$url = "rewards/modify";
		$data = "rewardId=$Id&rewardMediaToken=$token";
		$response = $this->Post ( $url, $data );
		return $response->data->reward;
	}
}